///--------------------------------------------------------------------------//
///	@pgm		AVR011 for CDI No 1-1
///	@version	0.02
///	@date		2007/02/28
///	@author 	؂񂬂񂭂
///	@remarks	sbNAbvpX̗オmA݃JE^]
///				𔻒f(12000`500 = 0 - 115)BpXmɁAΉe[
///				u̐ipf[^Waitɓ_΂
///
///	@modify		2007/03/05
///				sbNAbvpX̃`^OΉ
///				G[DUTY䌸ǉ
///				sbNAbvpX̐t]}Nǉ
///--------------------------------------------------------------------------//
#include <avr/io.h>
#define	__AVR_HAVE_LPMX__	1
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include <avr/interrupt.h>
#include <compat/deprecated.h>

//#define	_DEBUG	1
#define		_USE_USART	1
//#define	_PLUS_PULS_IS_PB4	1		// 1 - 1 @ ̓Rg P|Q@̓Rg͂ 
#define _DEF_CPU 1000000UL  				// ftHgCPUx 1 MHzƂ
#define	CPUX	 (F_CPU / _DEF_CPU)			// ftHgCPỦ{`(F_CPU̓vWFNgIvV)
//----------------------------------------------------------------------------//
///	@macros		萔`
//----------------------------------------------------------------------------//
#define	CNT_5MS_64DIV_256DIV		((unsigned)(0.3 * CPUX))
#define	CNT_1S_1024DIV				((unsigned)(976.5 * CPUX))
#define	CNT_500MS_1024DIV			((unsigned)(488.3 * CPUX))
#define	CNT_200MS_1024DIV			((unsigned)(195.3 * CPUX))
#define	CNT_1MS_64DIV				((unsigned)(15.62 * CPUX))
#define	CNT_500US_64DIV				((unsigned)(7.81 * CPUX))
#define	CNT_300US_64DIV				((unsigned)(4.69 * CPUX))
#define	CNT_100US_64DIV				((unsigned)(1.56 * CPUX))
#define	CNT_20US_64DIV				((unsigned)(0.31 * CPUX))
#define	CNT_13US_64DIV				((unsigned)(0.2 * CPUX))
#define	F200KHZ						((unsigned)(5 * CPUX))
#define	F160KHZ						((unsigned)(6.25 * CPUX))


#define	STARTUP_WAIT				CNT_500MS_1024DIV	// vOJn̑ҋ@(0.5b)
#define	TIME_CHARTRING				(CNT_5MS_64DIV_256DIV * 6)	// 5~b

#define	STOP_SWITCH_TIMES_BY64			CNT_300US_64DIV
#define	STOP_TRIG_TIMED_BY64			CNT_20US_64DIV
#define	STOP_SWITCH_TIMES_ERROR_BY64	CNT_500US_64DIV

#define	INIT_FREQ				F200KHZ
//#define	MAX_DUTY				(OCR0A >> 1)	// DUTY50%
#define	MAX_DUTY				(INIT_FREQ >> 1)	// DUTY50%
#define	MIN_DUTY				(INIT_FREQ / 10)	// DUTY10%
#define	PICKUP_ON_TIME			CNT_13US_64DIV

#define	PICUP_BTDC				19			// pXWFl[^̏㎀_̃}CiXpx
#define	USART_BAURATE			9600UL		// ʐM{[[g
#define	MAX_SAFE_WAIT			1
#define	MAX_TRIG_WAIT			CNT_20US_64DIV
#define	MAX_FIRE_WAIT			CNT_100US_64DIV		// _΂̎̑ҋ@
#define	MAX_SCR_ERROR_TIMES		80			// ̉񐔘AŔd2.5VꍇATCX^~sƌȂĔU~
#define	MAX_SCR_ERROR_RETRY		10

// tO̒l					
#define	TEST_TRIG_REQ_BIT		0			// eXg{^NGXg(`^O΍)
#define	EVT_TRIG_DOWN			1			// eXg{^Cxg
#define	EVT_TRIG_UP				2			// eXg{^ǂƂCxg
#define	REQ_PULS				3			// sbNAbvpXMCxg
#define	REQ_FIRE				4			// _ΐMMҋ@
#define	REQ_WRITE_EPROM			5			// EEPROM
#define	STOP_SWITCHING			6			// U~w
#define	INVERTER_BIT			7

#define	PULS_CHECK1				5
#define	PULS_CHECK2				4
#define	REQ_PRE_PULS			3

#define	_B_TEST_TRIG		PD2				// eXg{^
#define	_B_SWITCHING		PD5				// XCb`O|[g
#define	_B_TRIG				PD6				// _΃pXo̓|[g
#ifdef	_PLUS_PULS_IS_PB4
#define	_B_PULS_IN_M		PB3				// _΃^C~OpXM̓|[g(ʑ)
#define	_B_PULS_IN_P		PB4				// _΃^C~OpXM̓|[g(ʑ)
#else
#define	_B_PULS_IN_M		PB4				// _΃^C~OpXM̓|[g(ʑ)
#define	_B_PULS_IN_P		PB3				// _΃^C~OpXM̓|[g(ʑ)
#endif
#define	_B_VOLTAGE1			PB1				// dĎ|[g(d)
#define	_B_VOLTAGE0			PB0				// dĎ|[g(3`5Vȏ゠邩ǂĎ)
#define	_B_TEST_LED			PD4				// fobOpLEDo̓|[g
#define _B_CONFIG0			PD2				// ݒfBbvXCb`|[g
#define _B_CONFIG1			PD3				// ݒfBbvXCb`|[g

#define	_B_T1_UPPDT			0				// ^CJEgXVtOrbg
#define	_B_T1_USE			1				// ^C}PݎgptOrbg

#define	IsBitSet(Char, nBit)	(Char & (1 << nBit))
#define	IsBitClear(Char, nBit)	(!(Char & (1 << nBit)))
#define	BitSet(Char, nBit)		(Char |= (1 << nBit))
#define	BitsSet(Char, B1, B2)	(Char |= (1 << B1 | 1 << B2))
#define	BitClear(Char, nBit)	(Char &= ~(1 << nBit))
#define	BitsClear(Char, B1, B2)	(Char &= ~(1 << B1 | 1 << B2))

#define	NopS(nCnt)		\
		{					\
			uint8_t		tmp;	\
		asm volatile(		\
		"			ldi	%0, %1			\t\n"		\
		"LOOP_%=:	nop					\t\n"		\
		"			dec	%0				\t\n"		\
		"			brne	LOOP_%="	: "=d"(tmp) : "I"((nCnt - 2)>>2)		);	\
		}
#define	nop()	{	asm volatile("nop");	}

#define	Wait(time)	{\
			TIFR 	= (1 << TOV1);	\
			TCNT1	= ~time;		\
			while(!(TIFR & (1 << TOV1)));	\
		}

#ifdef _USE_USART
//	RS-232C ʐMp R}h
#define	_SCMD_WKUP1		'*'
#define	_SCMD_WKUP2		'!'
#define	_RCMD_SETUP0	's'
#define	_RCMD_SETUP1	'u'
#define	_RCMDS_FIN0		'f'
#define	_RCMDS_FIN1		'@'
#define	_RCMDS_FIN2		'?'

#define	_RCMD_GETAT0	'g'
#define	_RCMD_GETAT1	'@'
#define	_RCMD_SETAT0	's'
#define	_RCMD_SETAT1	'@'
#define	_SCMD_OK		0xfa
#define	_SCMD_BAD		0xfd
#endif
//----------------------------------------------------------------------------//
///	@prottypes	vg^Cv錾
//----------------------------------------------------------------------------//
void	init();						// 
char	CdiCtlrer();				// ipf[^XVƒʐM
void	CdiFunc();					// CDĨC

//----------------------------------------------------------------------------//
/// const datas on flash memory
///	@datas	萔e[uȂ
//----------------------------------------------------------------------------//
prog_uint16_t	gNextCount[] = {
	 	0x061b, 0x0628, 0x0635, 0x0643, 0x0651, 0x065f, 0x066d, 0x067c,
		0x068b, 0x069a, 0x06a9, 0x06b9, 0x06c9, 0x06d9, 0x06e9, 0x06fa,
		0x070b, 0x071d, 0x072f, 0x0741, 0x0753, 0x0766, 0x077a, 0x078d,
		0x07a2, 0x07b6, 0x07cb, 0x07e1, 0x07f7, 0x080d, 0x0824, 0x083b,
		0x0853, 0x086c, 0x0885, 0x089e, 0x08b9, 0x08d4, 0x08ef, 0x090b,
		0x0928, 0x0946, 0x0964, 0x0984, 0x09a4, 0x09c4, 0x09e6, 0x0a09,
		0x0a2d, 0x0a51, 0x0a77, 0x0a9e, 0x0ac6, 0x0aef, 0x0b19, 0x0b45,
		0x0b72, 0x0ba1, 0x0bd1, 0x0c02, 0x0c35, 0x0c6a, 0x0ca1, 0x0cda,
		0x0d15, 0x0d52, 0x0d91, 0x0dd2, 0x0e16, 0x0e5d, 0x0ea6, 0x0ef3,
		0x0f43, 0x0f96, 0x0fed, 0x1047, 0x10a6, 0x1109, 0x1171, 0x11de,
		0x1250, 0x12c8, 0x1347, 0x13cc, 0x1459, 0x14ee, 0x158b, 0x1632,
		0x16e4, 0x17a1, 0x186a, 0x1942, 0x1a29, 0x1b21, 0x1c2c, 0x1d4c,
		0x1e85, 0x1fd9, 0x214b, 0x22e1, 0x249f, 0x268d, 0x28b1, 0x2b16,
		0x2dc7, 0x30d4, 0x3451, 0x3858, 0x3d09, 0x4296, 0x493e, 0x5162,
		0x5b8e, 0x68a2, 0x7a12, 0x927c
	};// global vars


#define	PICKUP_BTDCM		60
#define	PICKUP_BTDCP		20
#define	PICKUP_CHG			1
#define	IDX_PICKUP_CHG		106
#define	TABLE_ITEM_NUM			116

EEMEM unsigned char __SDatas[] = {
		19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 
		19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 
		19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 
		19, 19, 19, 19, 19, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 
		20, 20, 20, 20, 20, 20, 20, 19, 19, 19, 19, 19, 19, 19, 19, 19, 
		19, 19, 19, 19, 19, 19, 19, 18, 18, 18, 18, 18, 18, 18, 18, 18, 
		18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 17, 17, 17, 17, 17, 17, 
		17, 17, 17, 17 
};

#define cnEntry TABLE_ITEM_NUM
#define	IDX_PICKUP_CHG		106				// sbNAbvpX(A̐ؑ։]CfNX)

//----------------------------------------------------------------------------//
//	@variables	O[oϐ`
//----------------------------------------------------------------------------//
//
//----------------------------------------------------------------------------//
//	@INTRRUPT FUNCTIONS
//----------------------------------------------------------------------------//
/*	
//--------- Timer1 rv ------------------//
ISR(TIMER1_COMPA_vect)
{
}
*/
//------------------------------------------------------//	
//	@func	(^C}[PI[o[t[)
//	@brief		PORTB	B0ɓ_ΐMo͂
//------------------------------------------------------//	
/*
ISR(TIMER1_OVF_vect)
{
}
*/

uint8_t EEPROM_read(uint8_t ucAddress)
{
	while(IsBitSet(EECR, EEPE));	// EEROMbusy
	EEAR = ucAddress;		// EEPROMڽݒ 
	EECR |= (1 << EERE);	 		// EEPROMǂݏoJn 
	return EEDR;	 				// EEPROMǂݏol擾,A 
}

#ifdef _USE_USART
uint8_t EEPROM_write(uint8_t ucAddress, uint8_t ucData)
{
	if(IsBitSet(EECR, EEPE))
		return	1;

	EECR = (0<<EEPM1) | (0<<EEPM0);	// Ə
	EEAR = ucAddress;				// EEPROMڽݒ 
	EEDR = ucData;	 				// EEPROMݒlݒ 
	EECR |= (1<<EEMPE);	 			// EEPROMϽ ۸ы 
	EECR |= (1<<EEPE);	 			// EEPROM۸ݸފJn 
	return  0;
}

#endif
//----------------------------------------------------------------------------//
//	@func	main
//----------------------------------------------------------------------------//
int main()
{
//			s
	init();							// ŃG[胊ZbgKvȏꍇ
#ifdef _USE_USART
	if(CdiCtlrer() > 1)
		return  1;
#endif
	CdiFunc();
	return  0;
}
//----------------------------------------------------------------------------//
//	@func	init
//----------------------------------------------------------------------------//
void	init()
{
	cli();							// SĂ̊荞݂͎gȂ̂ŋ֎~

	//----- AiO-------------------------//
									// dɎԂ̂ŃAiȌ͕ɂ
	DIDR	= (1 << AIN1D);			// PB1̂݃AiÓBfW^͂֎~
	ACSR	= (1 << ACBG);			// Rp[^̔񔽓]͂d 1.23 

	//------ X^[gAbvEFCg--------------//
	TCCR1B 	= 0b00000101;			// ^C}P1024iEFCNAbvpWaiẗׁj
	TCNT1	= ~(STARTUP_WAIT);
	while(!(TIFR & (1 << TOV1)));	// ҋ@
	//----- O[oϐ  -----------------------------------//
//
	//----- o͐ݒ ----------------------------//
	//!!! L͖gps듮h~ׂ̈ɏo͂ƂĂ
	DDRB	= 	(1 << PB7 | 1 << PB6 | 1 << PB5) ;
	DDRD	= 	(1 << _B_TRIG | 1 << _B_TEST_LED | 1 << _B_SWITCHING);

	//----- ͐ݒ(vAbv------------------//
									// PB0͓͂A{̓v_EƂȂ̂Őݒ肵Ȃ
	PORTD	= 	(1 << _B_CONFIG0 | 1 << _B_CONFIG1);
	PORTB	= 	(1 << _B_PULS_IN_M  | 1 << _B_PULS_IN_P | 1 << _B_TEST_TRIG) | 
				//----- gpsHIxɂĂ------------//
				(1 << PB7 | 1 << PB6 | 1 << PB5);
//
#ifdef _USE_USART
	//----- VAʐMݒ --------------------//
	UBRRL	= (F_CPU / (16 * USART_BAURATE)) - 1;
	UCSRB	= (1 << RXEN | 1 << TXEN | 0 << RXCIE | 0 << TXCIE);	//	M, 荞݂s
//	UCSRC	= 0b00000110;			// 񓯊EpeBAXgbvrbgPAf[^rbgW
	UCSRC	= 0b00111110;			// 񓯊EpeBAXgbvrbgQAf[^rbgW
#endif
//
}

#ifdef _USE_USART
///-----------------------------------------------------------//
///	@func	USARTGetByte
///-----------------------------------------------------------//
uint8_t	USARTGetByte(uint8_t *pError, unsigned tout)
{
	uint8_t		cGet, nRet = 0, seq = 0;
//
	if(tout == 0)
		TCCR1B 	= 0;							// ^C}P~
	else
		TCCR1B 	= 0b00000101;					// ^C}P1024
	TCNT1	= ~tout;							// 
	BitSet(TIFR, TOV1);							// I[o[t[rbgNA
	while(!IsBitSet(TIFR, TOV1))
	{
		if(!seq)
		{
			if(UCSRA & (1 << RXC | 1 << FE | 1 << DOR | 1 << UPE))
			{
				if(UCSRA & (1 << FE | 1 << DOR | 1 << UPE))
				{
					while(IsBitSet(UCSRA, RXC))	// ǂݎ̂
						cGet = UDR;
					nRet = 1;					// ُ
				}
				else
					cGet = UDR;					// 
				seq++;
			}
		}
		else
		{
			if(IsBitSet(UCSRA, UDRE))				// Mobt@󂢂
			{
				UDR	= nRet;								// ^[R[hM
				break;
			}
		}
	}

	if(IsBitSet(TIFR, TOV1))
		*pError = 0xff;
	else
		*pError = nRet;	
	return  cGet;
}

uint8_t	USARTPutByte(uint8_t c, unsigned tout)
{
	uint8_t	seq = 0, ret;
//
	TCCR1B 	= 0b00000101;						// ^C}P1024
	TCNT1	= ~tout;							// 
	BitSet(TIFR, TOV1);							// I[o[t[rbgNA

	while(!IsBitSet(TIFR, TOV1))
	{
		if(!seq)
		{
			if(IsBitSet(UCSRA, UDRE))
			{
				UDR	= c;
				seq++;
			}
		}
		else
		{
			if(UCSRA & (1 << RXC | 1 << FE | 1 << DOR | 1 << UPE))
			{
				ret = UDR;
				return  ret;
			}
		}
	}
	if(IsBitSet(TIFR, TOV1))
		return  0xff;
	return  0;
}

//----------------------------------------------------------------------------//
///	@func	CdiCtlrer
///	@brief	Rg[W[ƒʐMsAvꍇipf[^XV
///
///	@return		0 	q@ڑ
///	@return		1	q@ڑŃZbgAbv[hŖꍇ
///	@return		2	ZbgAbv[h̏ꍇ
//----------------------------------------------------------------------------//
char	CdiCtlrer()
{
	uint8_t	 	idx, c, cmd, nRet;
	char		diff, iAngle,  tmp, i;
//
	if(USARTPutByte(_SCMD_WKUP1, CNT_200MS_1024DIV) == 0xff)	// WakeUp pR}hM
		return  0;
	if(USARTPutByte(_SCMD_WKUP2, CNT_200MS_1024DIV) == 0xff)	// WakeUp pR}hM
		return  0;

	// WakeUppR}hMA0.2bȓɃZbgAbvR}h󂯎ꂽꍇA
	// ݒJnƌȂ
	i		= 0;
	cmd		= 0;

	while(i < 2)				// 0.2bԔ
	{
		c = USARTGetByte(&nRet, CNT_200MS_1024DIV);
		if(nRet != 0)
			break;
		if(i == 1)
		{
			if(c == _RCMD_SETUP1)
				cmd |= 2;
			i++;
			break;
		}
		else
		if(i == 0)
		{
			if(c == _RCMD_SETUP0)
				cmd |= 1;
			i++;
		}
	}

	if(i < 2)
		return  0;								// q@ڑ

	USARTPutByte(120, CNT_1S_1024DIV);	// ő]f[^M
	USARTPutByte(cnEntry, CNT_1S_1024DIV);	// e[uM

	if(cmd != 3)								// ZbgAbv[hŖꍇ
		return  1;								// ŏI
//
	BitSet(PORTD,_B_TEST_LED);
	i		= 0;
	cmd		= 0;
	idx		= 0;
	while(1)
	{
		c = USARTGetByte(&nRet, 0);
		if(nRet != 0)
			break;

		if(i == 0)
		{
			if(c == _RCMD_GETAT0)
				cmd = 1;
			else
			if(c == _RCMD_SETAT0)
				cmd = 2;
			else
			if(c == _RCMDS_FIN0)
				cmd = 3;
			else
				cmd = 0x80;					// G[ƌӖ
			i++;
		}
		else
		if(i == 1)
		{
			if(c != '@')
				cmd = 0x80;					// G[ƌӖ
			i++;
		}
		else
		if(i == 2)
		{
			if(cmd == 0x80)					// [ꍇ
			{
				USARTPutByte(_SCMD_BAD, CNT_1S_1024DIV);
			}
			else
			{
				if(cmd == 1)
				{
					idx = c;
					iAngle = EEPROM_read(&__SDatas[idx]);
					USARTPutByte(iAngle, CNT_1S_1024DIV);	// pxf[^M
				}
				if(cmd == 2)
				{
					tmp = c;
					diff = c - iAngle;
					for(i = idx; i >= 0; i--)
					{
						iAngle = EEPROM_read(&__SDatas[i]) + diff;
						while(EEPROM_write(&__SDatas[i], iAngle));
					}
					USARTPutByte(_SCMD_OK, CNT_1S_1024DIV);
				}
				if(cmd == 3)
				{
					USARTPutByte(_SCMD_OK, CNT_1S_1024DIV);
					break;
				}
			}
			i = 0;
		}
	}

	BitClear(PORTD,_B_TEST_LED);
	return  2;
}
#endif
///----------------------------------------------------------------------------//
///	@func	CdiFunc
///	@remarks	vOȂ̂Ń[Jϐ̏sĂȂ	
//----------------------------------------------------------------------------//
void CdiFunc()
{
	unsigned	uTmp, 
				nextCount,
				nMaxWait,
				uCntOther,				// ̑̏s߂̑҂ԃJEg
				*pNextCount,
				iPreWait,
				iFireTime;
	long		lTemp;
	uint8_t		tmp,
				bPickup,
				nMaxDuty,
				nSavTcnt1H = 0,
				nStopSpan,
				uScrError = 0,
				uScrErrorTimes = 0,
				bFlags  = 0, 				// rbgtO
				bFlags2 = 0,
//				uCntPuls = 0,
				idxCurRpm,					// ݉]CfNX
				nError = 0,					// G[ꍇ
				nCntError;					// 
#ifdef	_DEBUG
//!!!! For Debug --->//
	uint8_t		cPDSave = 0,
				cPBSave = (1 << _B_TEST_TRIG | 1 << _B_PULS_IN_M | 1 << _B_PULS_IN_P),
				idxTest = cnEntry - 1,
				nDebugCnt = 0,
				nChatring = 0;
//<--- For Debug !!!!//
#endif
#ifdef _USE_USART
	// ʐM𑗐MpɕύX
	UCSRB	= (1 << TXEN);	
#endif

	// ^C}֘A̍ďPWMUݒ
	TCCR1B		= 0b00000011;				// ^C}P64Ŏgp
	TCCR0A		= 0b00100011;				// 	PWMOCR0ATOP,OC0B(PD5)o(BOTTOMHIAOCR0BvLO)
	TCCR0B  	= 0b00001001;				// 	PWM,^C}0Ou
	OCR0A		= INIT_FREQ;				//	Ugw肵lɕύX
	OCR0B		= 1;						//	DUTY1/ɐݒ
	nMaxDuty	= MAX_DUTY;
	TCNT1		= 0;
	TIFR		= (1 << TOV1);

	// fBbvXCb``FbN
	tmp = (PIND & (1 << _B_CONFIG0 | 1 << _B_CONFIG1));
	if(IsBitClear(tmp, _B_CONFIG0))
	{
	}
	else
	if(IsBitClear(tmp, _B_CONFIG1))
	{
	}
	else
	{
	}
/*
	//	őҋ@Ԃ߂
	tmp = EEPROM_read(&__SDatas[TABLE_ITEM_NUM - 1]);
	lTemp = PICKUP_BTDCP - tmp;

	if(lTemp > 0)
	{
		uTmp	= pgm_read_word(&gNextCount[TABLE_ITEM_NUM - 1]);
		lTemp 	= lTemp * uTmp / 360;
		nMaxWait = lTemp;
	}
	else
		nMaxWait = 	0;
*/
//
	PCMSK	= (1 << _B_PULS_IN_M);			// sbNAbvpXsŊ荞ݔ
	bPickup	= _B_PULS_IN_M;

	pNextCount 	= (unsigned*)&gNextCount[0];
	idxCurRpm 	= 0;
	nextCount 	= pgm_read_word(pNextCount++);

	//	loop
	while(1)
	{
		//------------- ^C}[P̉ʃoCgI[o[t[`FbN ---------------------//
		if(TCNT1H != nSavTcnt1H)
		{
			nSavTcnt1H	= TCNT1H;
			uCntOther++;

#ifdef _DEBUG
			//!!!! fobOp ---->
			nChatring++;
			//<--- fobOp !!!!//
#endif
		}

		if(nError)
		{
			if((uCntOther & 0x0fff) == 0)
			{
				nCntError = nError;
				uCntOther++;
			}
			
			if(nCntError && ((uCntOther & 0x7f) == 0))
			{
				if(PORTD & (1 << _B_TEST_LED))
				{
					PORTD &= ~(1 << _B_TEST_LED);
					nCntError--;
				}
				else
					PORTD |= (1 << _B_TEST_LED);
				uCntOther++;
			}
		}

		if(nError < 8)								// G[xWȂ瑱s
		{
			if(EIFR & (1 << PCIF))					// pX͂ꍇ
			{
				EIFR 	= (1 << PCIF);
//
				if(!IsBitSet(PINB, bPickup))
				{
					BitSet(bFlags2, REQ_PRE_PULS);
					iPreWait = TCNT1 + PICKUP_ON_TIME;
				}
				else
				{
					if(IsBitSet(bFlags2, REQ_PRE_PULS))
						nError |= 2;
					BitClear(bFlags, REQ_PRE_PULS);
				}
			}

			if(IsBitSet(bFlags2, REQ_PRE_PULS))
			{
				if(TCNT1 >= iPreWait)
				{
					if(!IsBitSet(PINB, bPickup))
					{
						BitSet(bFlags, REQ_PULS);
						BitClear(bFlags2, REQ_PRE_PULS);
/*
						if(!IsBitSet(PORTD, _B_TEST_LED))
							BitSet(PORTD,_B_TEST_LED );
						else
							BitClear(PORTD,_B_TEST_LED );
*/
					}
				}
			}

#ifdef _DEBUG
			//!!!! fobOp ---->
			if(IsBitSet(bFlags, TEST_TRIG_REQ_BIT))
			{
				if(nChatring >= TIME_CHARTRING)
				{
					if((PINB & (1 << _B_TEST_TRIG)) != (cPBSave & (1 << _B_TEST_TRIG)))
					{
						tmp = PINB;
						cPBSave &= ~(1 << _B_TEST_TRIG);
						cPBSave |= (tmp & (1 << _B_TEST_TRIG));
						if(tmp & (1 << _B_TEST_TRIG))
							BitSet(bFlags, EVT_TRIG_UP);
						else
							BitSet(bFlags, EVT_TRIG_DOWN);
					}
					BitClear(bFlags, TEST_TRIG_REQ_BIT);
				}
			}
			else
			{
				if((PINB & (1 << _B_TEST_TRIG)) != (cPBSave & (1 << _B_TEST_TRIG)))
				{
					BitSet(bFlags, TEST_TRIG_REQ_BIT);
					nChatring = 0;
				}
			}

			if(IsBitSet(bFlags, EVT_TRIG_DOWN))
			{
				BitClear(bFlags, EVT_TRIG_DOWN);
				idxTest -= 2;
				nDebugCnt++;
				if(nDebugCnt > 5)
					nDebugCnt  = 0;
			}

			if(idxCurRpm >= idxTest && nDebugCnt > 0)
				BitSet(bFlags, REQ_PULS);
			//<--- fobOp !!!!//
#endif

			if(IsBitSet(bFlags, REQ_PULS))
			{
				// ϐ
				uTmp	= TCNT1;
				TCNT1	=	0;

				if(idxCurRpm < cnEntry)
				{
					tmp = EEPROM_read(&__SDatas[idxCurRpm]);
					if(idxCurRpm < IDX_PICKUP_CHG)
						lTemp = PICKUP_BTDCM - tmp;
					else
						lTemp = PICKUP_BTDCP - tmp;
					if(lTemp > 0)
					{
						lTemp 	= lTemp * uTmp / 360;
						iFireTime	= (unsigned)lTemp;
					}
					else
						iFireTime = 	0;
				}
				else
					iFireTime = MAX_FIRE_WAIT;			//iFireTime = nMaxWait;

				if(IsBitSet(bFlags, STOP_SWITCHING))
					nError |= 4;
//				if(idxCurRpm <= 10)
//					nError |= 2; 


				BitSet(bFlags, REQ_FIRE);
				pNextCount = (unsigned*)&gNextCount[0];	// ]f[^Qƃ|C^擪
				nextCount = pgm_read_word(pNextCount++);// ]f[^擾	

#ifdef _USE_USART
				if(IsBitSet(UCSRA, UDRE))				// Mobt@󂢂Ăꍇ
					UDR	= idxCurRpm;					// WakeUp pR}hM
#endif

				idxCurRpm = 0;
				BitClear(bFlags, REQ_PULS);
				PCMSK	= (1 << _B_PULS_IN_M);			// (sbNAbvpXs)Ŋ荞ݔ
				bPickup	= _B_PULS_IN_M;
			}

			//------------- ݉]CfNXXV---------------------//
			if(TCNT1 > nextCount && idxCurRpm < cnEntry)
			{
				idxCurRpm++;
				nextCount = pgm_read_word(pNextCount++);
				if(idxCurRpm >= IDX_PICKUP_CHG)
				{
					PCMSK	= (1 << _B_PULS_IN_P);	// (sbNAbvpXs)Ŋ荞ݔ
					bPickup	= _B_PULS_IN_P;
				}
			}


			if(IsBitSet(bFlags, STOP_SWITCHING))	// U~̏ꍇ
			{
				BitClear(PORTD, _B_SWITCHING);		

				if(TCNT0 >= STOP_TRIG_TIMED_BY64)	// _ΐM~
					BitClear(PORTD, _B_TRIG);
				if(TCNT0 >= nStopSpan)				// U~Ԗ
				{
					BitClear(bFlags, STOP_SWITCHING);
					TCCR0A	= 0b00100011;			// 	PWMOCR0ATOP,OC0B(PD5)o(BOTTOMHIAOCR0BvLO)
					TCCR0B  = 0b00001001;			// 	PWM,^C}0Ou
					OCR0B	= 1;					//	DUTY1/ɐݒ
					TCNT0	= 0;
				}
			}
			else									// Ȕꍇ
			{
				//------------- d`FbN ---------------------//
				if(!IsBitSet(ACSR, ACO))			// dd荂
				{
					if(OCR0B > 1)					
						OCR0B--;
				}
				else
				{
					if(OCR0B < nMaxDuty)
						OCR0B++;
				}

				//------------- ُd`FbN   ---------------------//
				if(!IsBitSet(PINB, _B_VOLTAGE0))			// d2.5̏ꍇ
				{
					uScrError++;
				}
				else
				{
					uScrError = 0;
					uScrErrorTimes = 0;
					nMaxDuty	= MAX_DUTY;
				}
			}

			if(uScrError > MAX_SCR_ERROR_TIMES)				// d2.5VAꍇA
			{
				BitSet(PORTD,_B_TEST_LED);
				TCCR0A 		= 0;
				TCCR0B		= 0b00000011;			// ^C}0 64Ŏgp
				BitClear(PORTD, _B_SWITCHING);		// XCb`O~
				BitSet(bFlags, STOP_SWITCHING);		// M~w
				nError 		|= 1;					
				uScrError	= 0;
				nStopSpan	= STOP_SWITCH_TIMES_ERROR_BY64;
				TCNT0	= 0;
				uScrErrorTimes++;
				if(nMaxDuty > MIN_DUTY)
					nMaxDuty -= 5;
				if(uScrErrorTimes > MAX_SCR_ERROR_RETRY)	// gCĂdオȂꍇ
				{
					nError |= 8;					// ~ɂ
				}

			}

	//

			//------------- ^C}PI[o[t[(_Ώ)------------------//
			if(IsBitSet(bFlags, REQ_FIRE))					
			{
				if(TCNT1 >= iFireTime)
				{
					TCCR0A 		= 0;
					TCCR0B		= 0b00000011;		// ^C}0 64Ŏgp
					BitClear(PORTD, _B_SWITCHING);	// XCb`O~

					PORTD |= (1 << _B_TRIG);		// _ΐMo
	//				NopS(MAX_TRIG_WAIT);
	//				PORTD &= ~(1 << _B_TRIG);		// _ΐMNA
					BitClear(bFlags, REQ_FIRE);

					BitSet(bFlags, STOP_SWITCHING);	// M~w
					nStopSpan	= STOP_SWITCH_TIMES_BY64;
					TCNT0	= 0;
				}
			
			}
		}// End if(nError < 8)
	}// End while(1)
	return  0;
} 


